#pragma once

#include <memory>
#include <vector>

#include "message.h"
#include "slimchat.h"
#include "view.h"

class ViewChat : public View {
public:
	ViewChat(TgTUI& tgtui);
	virtual ~ViewChat();

	void setChat(const SlimChat* chat);
	int64_t getChat() const;

	virtual void paint() override;

	virtual int keyIn(int key) override;

	void updateMessages(const std::vector<std::shared_ptr<Message>>& messages);

private:
	const SlimChat* chat = nullptr;

	std::vector<std::shared_ptr<Message>> messages;
};
